Option Explicit

' noCopyright 2020 Dipisoft, script crit par D.PONNELLE
'
' A quoi sert ce script ?
' ~~~~~~~~~~~~~~~~~~~~~
' A lister des objets de l'annuaire ActiveDirectory (ventuellement limite
'  une certaine O.U.) en prcisant les attributs  rcuprer, les critres de
' recherche, etc... Il est galement possible de rechercher des lments fournis
' dans un fichier d'entre.
'
' Le temps d'excution varie en fonction du nombre d'objets de l'AD mais aussi
' des attributs rapatris. L'utilisation des attributs non-rpliqus (lastlogin,
' lastfailedlogin, badlogincount, lastvalidationserver, accountdisabled et
' isaccountLocked) ncessite d'interroger chaque contrleur, ce qui ralentit 
' normment le script et entrane une sollicitation accrue de l'AD. Avant de
' lancer le script sur l'intgralit de l'AD, il est donc vivement conseill de
' faire vos tests sur une O.U. peu peuple.
'
' L'excution du script s'effectue, depuis l'explorateur de fichiers, par un
' clic-droit sur ledit fichier puis "Ouvrir avec l'invite de commande" 
' (prfrable  "Ouvrir" tout court car il permet d'arrter le script facilement
' en faisant un CTRL+C). Il est galement possible de le lancer en mode ligne de
' commande en le passant en paramtre de l'excutable CSCRIPT.EXE (prfrable 
' WSCRIPT.EXE pour la mme raison que celle expose ci-dessus), prsent dans le
' dossier %windows%\System32.
'
' v1.0 (07/05/2013) : version initiale
' v1.1 (13/05/2013) : ajout d'un tri des valeurs indexes (groupes notamment)
' v1.2 (16/05/2013) : quelques modifs trs mineures avant publication
' v1.3 (02/10/2013) : le domaine de l'ActiveDirectory est maintenant dtermin automatiquement
'                     un traitement spcifique est ajout pour les attributs non rpliqus (LastLogin, LastFailedLogin, BadLoginCount) et LastValidationServer (qui n'est pas un attribut AD). Chaque contrleur est alors interrog pour rcuprer la valeur la plus "fraiche"
'                     il est  prsent possible de mentionner des attributs faisant rfrence  des dates (whenCreated, par exemple, correspondant  la date de cration du compte)
' v1.4 (11/12/2013) : ajout de la possibilit de spcifier un fichier d'entre contenant la liste des valeurs auxquelles la recherche sera restreinte
' v1.5 (22/01/2014) : changement de mthode pour dterminer la liste des contrleurs (maintenant on ne tient compte que des contrleurs de la foret sur laquelle la session est valide ; avant on prenait en compte l'ensemble des contrleurs, y compris ceux de la fort "racine")
' v1.6 (13/11/2014) : correction d'un bug dans la rcupration des champs multivalus (variable non dclare)
' v1.7 (04/04/2014) : ajout du traitement spcifique pour les attributs accountDisabled et isAccountLocked
'                     ajout de la constante PREFIXE permettant, par exemple, d'indiquer pour chaque ligne la valeur issue du fichier d'entre
' v1.8 (02/11/2016) : remplacement de l'arraylist (utilis pour les contrleurs) par un dictionary qui ne ncessite pas la prsence du Framework .NET 3.5.
'                     il reste toutefois un second arraylist optionnellement utilis en cas de traitement de champs multivalus. A voir pour son remplacement dans une prochaine version.
' v2.0 (18/10/2020) : ajout d'une fonctionnalit de recherche de mise  jour
'                     nettoyage avant publication sous le nom de "AccInfos" en remplacement de "UserInfos" car plus gnrique (UserInfos tait surtout ddi aux comptes utilisateurs) et moins sujet  confusion avec "QuickUserInfos"
'
' Ne pas modifier la valeur qui suit. Vous pourrez dsactiver la recherche de
' mise  jour quelques lignes plus bas, via la constante CHERCHER_MAJ.
Const VERSION = "2.0"


' ************************* Constantes personnalisables ************************

' Faut-il vrifier si une version plus rcente du script est disponible
' (non=false, oui=true) ?
Const CHERCHER_MAJ = true


' Si la vrification des mises  jour est active, renseigner l'ventuel proxy
'  utiliser pour se connecter  Internet (au format "nom_ou_adresse:port") ou
' laisser vide dans le cas d'une connexion directe.
Const PROXY = ""


' Nom du fichier dans lequel lequel se trouvent les lments qui seront 
' chercher. Laisser vide si vous ne souhaitez pas restreindre la recherche  une
' liste d'lments.
'Const FICHIER_ENTREE = "AccInfos_in.txt"
Const FICHIER_ENTREE = ""


' Nom du fichier dans lequel le rsultat sera vers.
Const FICHIER_SORTIE = "AccInfos_out.txt"


' Ajouter une ligne d'en-tte contenant le nom des colonnes (non=false,
' oui=true).
Const TITRE = true


' Entourer les valeurs de double-quotes (non=false, oui=true).
Const DOUBLE_QUOTER = true


' Caractre sparateur  utiliser pour sparer les champs dans le rsultat.
Const SEPARATEUR_COLONNES = ";"


' Caractre sparateur  utiliser pour sparer les valeurs des champs
' multivalus (constitus d'un tableau pouvant contenir plusieurs valeurs).
Const SEPARATEUR_VALEURS_CHAMPS_MULTIVALUES = "|"


' Dsigne l'ventuelle O.U. (y compris une arborescence d'O.U.)  laquelle on 
' veut restreinte la recherche, laisser vide si la recherche porte sur la 
' globalit de l'annuaire. Attention  ne pas spcifier les lments DC.
'Const OU = "OU=Compta,OU=Siege social"
Const OU = ""


' Liste des attributs  rapatrier pour chaque compte (voir
' https://docs.secureauth.com/display/KBA/Active+Directory+Attributes+List
' pour une liste dtaille).
'Const ATTRIBUTS = "sAMAccountName, sn, givenName, whenCreated, memberOf"
'Const ATTRIBUTS = "cn, operatingSystem, operatingSystemVersion, lastLogin"
Const ATTRIBUTS = "sAMAccountName, displayName, mail"


' Critre de la recherche. Si FICHIER_ENTREE est utilis, ne pas oublier de
' faire apparatre le champ concern dans le critre de la recherche (%v sera
' remplac  la vole par les valeurs contenues dans le fichier).
'Const CRITERE = "WHERE objectCategory='person' AND objectClass='user'" ' AND sAMAccountName='%v'"
'Const CRITERE = "WHERE objectCategory='computer' AND cn='%v'"
'Const CRITERE = "WHERE objectCategory='computer'"
Const CRITERE = "WHERE objectCategory='person' AND objectClass='user' AND givenName='damien'"


' Clause  utiliser pour le tri du rsultat (attention : si FICHIER_ENTREE est
' utilis, le rsultat sera en priorit class dans l'ordre du contenu de ce
' fichier), consitue de l'expression 'ORDER BY' suivie du ou des attributs,
' comme dans une requte SQL standard.
Const ORDRE = ""
'Const ORDRE = "ORDER BY displayName, cn DESC"
'Const ORDRE = "ORDER BY sAMAccountName"


' Chaine  insrer au dbut de chaque ligne de rsultat. Si vous souhaitez
' inclure la valeur du fichier d'entre, vous pouvez utiliser "%v" comme vu dans
' la constante CRITERE.
Const PREFIXE = ""
'Const PREFIXE = "%v"


' Si la boite de dialoque "Traitement termin" vous drange (surtout si le
' script est lanc par un traitement automatique), vous pouvez dsactiver son
' affichage grce  la constante suivante (non=false, oui=true).
Const AFFICHER_TRAITEMENT_TERMINE = true

' ******************************************************************************

Const ForReading = 1 ' on se demande pourquoi cette constante n'est pas nativement reconnue
Dim objShell, objFSO, objFichierEntree, objFichierSortie, objRootDSE, objOUDC, objConnexion, objCommande, objRecordSet, objUser, dicDCs
Dim strVersionDispo, strRootAD, strConfigAD, strOUDC, strDC, strLigne, strInfos
Dim v, i


' initialisation des objets
Set dicDCs = CreateObject("Scripting.Dictionary")
Set objShell = CreateObject("Wscript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFichierSortie = objFSO.CreateTextFile(FICHIER_SORTIE)

If CHERCHER_MAJ = true Then
	If ChercherSiMiseAjourDisponible() Then
		WScript.Quit
	End If
End If

If FICHIER_ENTREE <> "" Then
	If objFSO.FileExists(FICHIER_ENTREE) = False Then
		Msgbox "Le fichier d'entre spcifi ('" & FICHIER_ENTREE & "' n'a pas t trouv.", vbCritical, "AccInfos (par Dipisoft)"
		WScript.Quit
	ElseIf CRITERE = "" Then
		Msgbox "Quand la constante FICHIER_ENTREE n'est pas vide, la constante CRITERE doit aussi tre renseigne.", vbCritical, "AccInfos (par Dipisoft)"
		WScript.Quit
	ElseIf instr(CRITERE, "%v") = 0 Then
		Msgbox "Quand la constante FICHIER_ENTREE n'est pas vide, la constante CRITERE doit contenir une rfrence  '%v' (qui sera remplace successivement par chaque valeur du fichier en entre).", vbCritical, "AccInfos (par Dipisoft)"
		WScript.Quit
	End If
End If

' si la constante TITRE est dfinie, on prpare la ligne de titre et on l'ajoute au fichier
If TITRE = true Then
	strInfos = IIf(PREFIXE = "", "", "Compte")
	
	For Each v in Split(ATTRIBUTS, ",")
		strInfos = IIf(strInfos = "", "", strInfos & SEPARATEUR_COLONNES) & Trim(v)
	Next
	
	objFichierSortie.Write(strInfos) & vbCrLf
End If

' dtermination du domaine root de l'ActiveDirectory et de l'emplacement de la config
Set objRootDSE = GetObject("LDAP://RootDSE")
strRootAD = "LDAP://" & IIf(OU = "", "", OU & ",") & objRootDSE.Get("DefaultNamingContext")

' initialisation de la connexion  l'ActiveDirectory
Set objConnexion = CreateObject("ADODB.Connection")
objConnexion.Provider="ADsDSOObject"
objConnexion.Open("Active Directory Provider")

' prparation de l'objet utilis pour les requtes
Set objCommande = CreateObject("ADODB.Command")
objCommande.ActiveConnection = objConnexion
objCommande.Properties("Page Size") = 100
objCommande.Properties("Searchscope") = 2 'ADS_SCOPE_SUBTREE

' recherche de la liste des contrleurs de domaine (utiliss pour traiter les ventuels attributs non rpliqus que l'utilisateur aura spcifi dans la constante ATTRIBUTS)
' nouvelle mthode
strOUDC = "LDAP://OU=Domain Controllers," & objRootDSE.Get("DefaultNamingContext")
On Error Resume Next
Set objOUDC = Nothing
Set objOUDC = GetObject(strOUDC)
On Error Goto 0

If Not objOUDC Is Nothing Then
	objOUDC.Filter = Array("Computer")
	
	If Not (objOUDC Is Nothing) Then
		i = 0
		For Each v In objOUDC
			dicDCs.Add v.dnsHostName, ""
			i = i + 1
		Next
	End If
End If

If FICHIER_ENTREE <> "" Then
	Set objFichierEntree = objFSO.OpenTextFile(FICHIER_ENTREE, ForReading)

	Do Until objFichierEntree.AtEndOfStream
		' lecture d'une ligne dans le fichier
		strLigne = objFichierEntree.ReadLine
		
		' "nettoyage" de la ligne lue (on ne tient pas compte de l'ventuel commentaire, qu'il soit en dbut ou fin de ligne)
		strLigne = Split(Trim(strLigne) & SEPARATEUR_COLONNES, SEPARATEUR_COLONNES)(0)

		' si aprs le nettoyage la ligne n'est pas vide, on l'ajoute au tableau
		If strLigne <> "" Then
			' recherche des comptes
			objCommande.CommandText = "SELECT " & SupprimerAttributsSpeciaux(ATTRIBUTS) & ", distinguishedName FROM " & "'" & strRootAD & "' " & Replace(CRITERE, "%v", strLigne) & " " & ORDRE
			
			Set objRecordSet = objCommande.Execute
			
			Call TraiterResultat(Replace(PREFIXE, "%v", strLigne))
		End If
	Loop
	
	objFichierEntree.Close
Else
	' recherche des comptes
	objCommande.CommandText = "SELECT " & SupprimerAttributsSpeciaux(ATTRIBUTS) & ", distinguishedName FROM " & "'" & strRootAD & "' " & CRITERE & " " & ORDRE
	Set objRecordSet = objCommande.Execute
	
	Call TraiterResultat("")
End If

' libration des diffrents objets
Set objRecordSet = Nothing
Set objConnexion = Nothing
objFichierSortie.Close
Set objFichierSortie = Nothing

If AFFICHER_TRAITEMENT_TERMINE Then
	Msgbox "Traitement termin.", vbInformation, "AccInfos (par Dipisoft)"
End If

WScript.Quit

Function TraiterResultat(chainePrefixe)
	Dim varAttribut
	
	If Not(objRecordSet.EOF) Then
		' itration sur chaque compte trouv
		Do Until objRecordSet.EOF
			strInfos = chainePrefixe
			
			' itration sur chaque attribut spcifi dans la constante ATTRIBUTS
			For Each varAttribut in Split(LCase(ATTRIBUTS), ",")
				' s'agit-il d'un attribut "spcial" ?
				If DeterminerAttributSpecial(varAttribut) Then
					' oui...
					Dim strLastValidationServer, strValeur
					Dim datLastLoginMax, datLastFailedLoginMax
					Dim intBadLoginCountMax
					
					' initialisation des valeurs par dfaut
					datLastLoginMax = null
					datLastFailedLoginMax = null

					' itration pour chaque contrleur
					For Each strDC in dicDCs
						Dim datLastLogin, datLastFailedLogin
						Dim intBadLoginCount

						On Error Resume Next
						' recherche du compte sur le DC
						Set objUser = GetObject("LDAP://" & strDC & "/" & objRecordSet.Fields("distinguishedName").Value)
						
						datLastLogin = null
						datLastFailedLogin = null
						intBadLoginCount = 0
						
						datLastLogin = objUser.LastLogin
						datLastFailedLogin = objUser.LastFailedLogin
						intBadLoginCount = objUser.BadLoginCount
						On Error Goto 0
						
						' la date de denire connexion est-elle plus rcente que celle dj connue ?
						If IsNull(datLastLoginMax) Or datLastLogin > datLastLoginMax Then
							' oui... alors on la mmorise ainsi que le nom du contrleur
							datLastLoginMax = datLastLogin
							strLastValidationServer = strDC
						End If
						
						' la date de denire erreur de connexion est-elle plus rcente que celle dj connue ?
						If IsNull(datLastFailedLoginMax) Or datLastFailedLogin > datLastFailedLoginMax Then
							' oui... alors on la mmorise ainsi que le nombre d'erreurs
							datLastFailedLoginMax = datLastFailedLogin
							intBadLoginCountMax = intBadLoginCount
						End If
					Next
					
					' en fonction de l'attribut, on retourne la valeur correspondante...
					Select Case varAttribut
					Case "lastlogin"
						strValeur = datLastLoginMax
						
					Case "lastfailedlogin"
						strValeur = datLastFailedLoginMax
						
					Case "badlogincount"
						strValeur = intBadLoginCountMax
						
					Case "lastvalidationserver"
						strValeur = strLastValidationServer
					
					Case "accountdisabled"
						Set objUser = GetObject("LDAP://" & objRecordSet.Fields("distinguishedName").Value)
						strValeur = objUser.AccountDisabled
						
					Case "isaccountlocked"
						Set objUser = GetObject("LDAP://" & objRecordSet.Fields("distinguishedName").Value)
						strValeur = objUser.IsAccountLocked
						
					End Select
				Else
					' non... prend la valeur telle quelle (aprs un trim quand mme)
					strValeur = ExtraireValeur(Trim(varAttribut))
				End If

				' s'il le faut, on entoure de double-quotes
				If DOUBLE_QUOTER Then
					strValeur = """" & strValeur & """"
				End If

				' et enfin on ajoute l'info  la chaine
				strInfos = IIf(strInfos = "", "", strInfos & SEPARATEUR_COLONNES) & strValeur
			Next
			
			' versement de la ligne dans le fichier
			objFichierSortie.Write(strInfos) & vbCrLf
			
			' on passe  l'enregistrement suivant
			objRecordSet.MoveNext
		Loop
	ElseIf chainePrefixe <> "" Then
		objFichierSortie.Write(chainePrefixe) & vbCrLf
	End If
End Function

Function ExtraireValeur(attribut)
	'
	' retourne la valeur de l'attribut spcifi de l'enregistrement courant
	'
	Dim objTableau, objDate
	Dim varValeur, v
	Dim strValeur, strValeurs
	Dim datDate
	Dim lngHigh, lngLow
		
	' inhibition des erreurs
	On Error Resume Next
	
	' tentative de rcupration de la valeur de l'attribut
	varValeur = objRecordSet.Fields(Trim(attribut)).Value
	
	' erreur rencontre ?
	If (Err.number <> 0) Then
		' oui... il s'agit probablement d'un objet (une date par exemple)
		Err.Clear
		
		' rcupration de l'objet
		Set objDate = objRecordSet.Fields(Trim(attribut)).Value
		
		' erreur rencontre ?
		If (Err.Number <> 0) Then
			' oui... valeur non reconnnue
			ExtraireValeur = "???"
		Else
			' dcoupage de l'objet
			lngHigh = objDate.HighPart
			lngLow = objDate.LowPart
			
			' erreur rencontre ?
			If (Err.Number <> 0) Then
				' oui... valeur non reconnnue
				ExtraireValeur = "???"
			' partie basse infrieure  0 ?
			ElseIf (lngLow < 0) Then
				' oui... incrmentation de la partie haute
				lngHigh = lngHigh + 1
			End If
			
			' parties haute/basse = 0 ?
			If (lngHigh = 0) And (lngLow = 0) Then
				' oui... valeur vide
				ExtraireValeur = ""
			Else
				' on retourne la date correspondante
				ExtraireValeur = #1/1/1601# + (((lngHigh * (2 ^ 32)) + lngLow) / 600000000) / 1440
			End If
		End If
	Else
		' non...
		On Error Goto 0
		
		' est-ce un tableau de valeurs ?
		If isArray(varValeur) Then
			' oui...
			Set objTableau = CreateObject("System.Collections.ArrayList")
			
			' itration sur chaque valeur, s'il s'agit de l'attribut 'memberof', on ne prend que le nom du groupe et non la totalit de la valeur (CN=nomgroupe,OU=...)
			For Each v In varValeur
				If LCase(attribut) = "memberof." Then
					strValeur = Mid(v, 4, InStr(v, ",") - 4)
				Else
					strValeur = v
				End If
	
				objTableau.Add strValeur
			Next
			
			' tri de la liste
			objTableau.Sort()
			
			' reversement du contenu de la liste dans une chaine
			For Each v in objTableau
				strValeurs = IIf(strValeurs = "", "", strValeurs & SEPARATEUR_VALEURS_CHAMPS_MULTIVALUES) & v
			Next
			
			ExtraireValeur = strValeurs
		Else
			' non... juste une valeur standard
			ExtraireValeur = varValeur
		End If
	End If
End Function

Function IIf(condition, vrai, faux)
	'
	' mule l'oprateur conditionnel ternaire prsent dans certains langages
	'

	If condition Then
		IIf = vrai
	Else
		IIf = faux
	End If
End Function

Function SupprimerAttributsSpeciaux(Attributs)
	'
	' retourne la liste des attributs fournis en entre, pure des attributs dits "spciaux" (principalement les attributs non-rpliqus)
	'

	Dim strSortie
	Dim v
	
	For Each v in Split(LCase(attributs), ",")
		If DeterminerAttributSpecial(v) = false Then
			strSortie = IIf(strSortie = "", "", strSortie & ",") & v
		End If
	Next 
	SupprimerAttributsSpeciaux = strSortie
End Function

Function DeterminerAttributSpecial(attribut)
	'
	' retourne true si l'attribut spcifi en paramtre appartient  la liste des attributs pour lesquels un traitement spcifique est effectu (principalement les attributs non-rpliqus)
	'
		
	attribut = Trim(attribut)
	
	DeterminerAttributSpecial = (attribut = "lastlogin" or _ 
								attribut = "lastfailedlogin" or _ 
								attribut = "badlogincount" or _ 
								attribut = "lastvalidationserver" or _
								attribut = "accountdisabled" or _
								attribut = "isaccountLocked")
End Function

Function ChercherSiMiseAjourDisponible()
	Const URL_VERIF_VERSION = "https://www.dipisoft.com/file/_versions.php?apps=AccInfos"
	Const ARTICLE = "https://www.dipisoft.com/articles.php?lng=fr&pg=1972&mnuid=2211&tconfig=0"
	Dim objHttp, strReponse, strVersionDispo, p
	
	' instanciation de l'objet utilis pour interroger le rfrentiel des versions
	Set objHttp = CreateObject("MSXML2.ServerXMLHTTP.6.0")
	objHttp.Open "GET", URL_VERIF_VERSION, false
	
	' si la constante proxy est renseigne, alors on l'utilise
	If PROXY <> "" Then
		objHttp.setProxy 2, PROXY
	End If

	' inibhition des erreurs pour l'appel http
	On Error Resume Next
	
	' excution de la requte
	objHttp.send 

	' s'il y a eu erreur, alors on l'affiche
	If err.number <> 0 Then
		Msgbox "Impossible de se connecter au site de Dipisoft, peut-tre est-il indisponible ou que " & Iif(PROXY = "", "votre connexion  Internet ncessite de spcifier un proxy", "la constante PROXY a t dfinie de faon incorrecte") & "." & vbCrLf & vbCrLf & "*** " & err.description & vbCrLf & "Le traitement va se poursuivre malgr tout.", vbExclamation, "AccInfos (par Dipisoft)"
	Else
		On Error Goto 0

		If objHttp.status = 200 Then
			strReponse = objHttp.responseText
			p = instr(strReponse, "=")
			
			If p > 0 Then
				strVersionDispo = Replace(Replace(Mid(strReponse, p + 1), vbLf, ""), vbCr, "")
				
				If strVersionDispo > VERSION Then
					If Msgbox("La version " & strVersionDispo & " est disponible. Rendez-vous sur le site de Dipisoft pour la rcuprer !", vbQuestion Or VbYesNo, "AccInfos (par Dipisoft)") = vbYes Then
						objShell.Run ARTICLE
						ChercherSiMiseAjourDisponible = true
						Exit Function
					End If
				End If
			End If
		Else
			Msgbox "Impossible de se connecter au site de Dipisoft, peut-tre est-il indisponible ou que " & Iif(PROXY = "", "votre connexion  Internet ncessite de spcifier un proxy", "la constante PROXY a t dfinie de faon incorrecte") & "." & vbCrLf & vbCrLf & "*** " & err.description & vbCrLf & "Le traitement va se poursuivre malgr tout.", vbExclamation, "AccInfos (par Dipisoft)"
		End If
	End If
End Function